## morse-simulator 0.5.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.6)

set(PACKAGE_NAME morse)
set(PACKAGE_VERSION 0.5.2)

option(BUILD_CORE_SUPPORT "Build and install morse core" ON)
option(BUILD_DOC_SUPPORT "Build and install morse documentation (Requiere Sphinx)" ON)

option(BUILD_POCOLIBS_SUPPORT "Build pocolibs framework support" OFF)
option(BUILD_YARP2_SUPPORT "Build yarp framework support" OFF)
option(BUILD_ROS_SUPPORT "Build ROS middleware support" OFF)
option(BUILD_MOOS_SUPPORT "Build MOOS middleware support" OFF)
option(BUILD_HLA_SUPPORT "Build HLA middleware support. Also used for distributed HLA simulation." OFF)

option(PYMORSE_SUPPORT "Build and install the Python bindings for MORSE." OFF)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/config/)
find_package(PkgConfig REQUIRED)

find_package(Python32Interp REQUIRED)

if (NOT PYTHON3INTERP_FOUND)
	MESSAGE(FATAL_ERROR "Can't find python 3.2 on your system")
endif(NOT PYTHON3INTERP_FOUND)

find_package(Python32Libs REQUIRED)

EXECUTE_PROCESS(COMMAND
					${PYTHON3_EXECUTABLE} -c "import distutils.sysconfig, sys; sys.stdout.write(distutils.sysconfig.get_python_lib(1,0,\"\"))"
					OUTPUT_VARIABLE PYTHON_INSTALL
					ERROR_VARIABLE PYTHON_STDERR
					RESULT_VARIABLE PYTHON_ERR
				)
if(NOT PYTHON_INSTDIR)
	SET(PYTHON_INSTDIR ${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL}) 
endif(NOT PYTHON_INSTDIR)
MESSAGE(STATUS "will install python files in ${PYTHON_INSTDIR}")

if (BUILD_YARP2_SUPPORT)
	EXECUTE_PROCESS(COMMAND 
					${PYTHON3_EXECUTABLE} -c "import yarp;"
					RESULT_VARIABLE YARP_PY_ERR
				   )
	if (YARP_PY_ERR)
		MESSAGE(FATAL_ERROR "BUILD_YARP_SUPPORT is required, but '${PYTHON3_EXECUTABLE}' can't find yarp python binding")
	endif (YARP_PY_ERR)
endif(BUILD_YARP2_SUPPORT)


# check to make sure pymoos is installed
if (BUILD_MOOS_SUPPORT)
	EXECUTE_PROCESS(COMMAND 
					${PYTHON3_EXECUTABLE} -c "import pymoos.MOOSCommClient;"
					RESULT_VARIABLE MOOS_PY_ERR
				   )
	if (MOOS_PY_ERR)
		#message(${MOOS_PY_ERR})
		#MESSAGE(FATAL_ERROR "BUILD_MOOS_SUPPORT is required, but '${PYTHON3_EXECUTABLE}' can't find MOOS python binding")
	endif (MOOS_PY_ERR)
endif(BUILD_MOOS_SUPPORT)


IF (BUILD_POCOLIBS_SUPPORT)
	pkg_check_modules(POCOLIBS REQUIRED pocolibs)
	find_package(SWIG REQUIRED 2.0.4)
endif(BUILD_POCOLIBS_SUPPORT)

if (BUILD_HLA_SUPPORT)
	EXECUTE_PROCESS(COMMAND 
					${PYTHON3_EXECUTABLE} -c "import hla;"
					RESULT_VARIABLE HLA_PY_ERR
				   )
	if (HLA_PY_ERR)
		MESSAGE(FATAL_ERROR "BUILD_HLA_SUPPORT is required, but '${PYTHON3_EXECUTABLE}' can't find 'hla' python binding")
	endif (HLA_PY_ERR)
endif(BUILD_HLA_SUPPORT)

ADD_SUBDIRECTORY(src)

IF(BUILD_CORE_SUPPORT)
INSTALL (DIRECTORY data examples addons
	     DESTINATION ${CMAKE_INSTALL_PREFIX}/share/morse
         REGEX .*blend.$ EXCLUDE
         REGEX .*py.$ EXCLUDE
		 REGEX .*clients.* EXCLUDE
		)

CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/bin/morse.in
	${CMAKE_CURRENT_BINARY_DIR}/bin/morse
	)
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/bin/morseexec.in
	${CMAKE_CURRENT_BINARY_DIR}/bin/morseexec
	)
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/bin/multinode_server.in
	${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server
	)
INSTALL(PROGRAMS
		${CMAKE_CURRENT_BINARY_DIR}/bin/morse
		${CMAKE_CURRENT_BINARY_DIR}/bin/morseexec
		${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server
		DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
	    )
ENDIF()

ADD_SUBDIRECTORY(bindings)

###### Testing ######
EXECUTE_PROCESS(COMMAND
				${PYTHON3_EXECUTABLE} -c "import pymorse"
								RESULT_VARIABLE PYTHON_ERR
								OUTPUT_QUIET
								ERROR_QUIET
				)
IF (PYTHON_ERR)
	MESSAGE(WARNING "Can't run test, pymorse is required but cannot be found.\nYou may want to install it first.")
ELSE()
	enable_testing()
	ADD_SUBDIRECTORY(testing)
ENDIF()

IF (BUILD_DOC_SUPPORT)
### Doc target ###
CONFIGURE_FILE(
	${CMAKE_CURRENT_SOURCE_DIR}/doc/conf.py.in
	${CMAKE_CURRENT_BINARY_DIR}/doc/conf.py
	)

FIND_PROGRAM(SPHINX_BUILD NAMES sphinx-build)
IF (NOT SPHINX_BUILD)
	MESSAGE(STATUS "Can't find sphinx-build : will not build the documentation")
ELSE()
	SET (SPHINX_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc/html)
	SET (SPHINX_LATEX_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc/tex)
	SET (SPHINX_MAN_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc/man)
	ADD_CUSTOM_COMMAND(
		OUTPUT ${SPHINX_OUTPUT}
		COMMAND ${SPHINX_BUILD} -b html
								-c ${CMAKE_CURRENT_BINARY_DIR}/doc
								   ${CMAKE_CURRENT_SOURCE_DIR}/doc/morse
								   ${SPHINX_OUTPUT}
	)

	ADD_CUSTOM_TARGET(doc ALL DEPENDS ${SPHINX_OUTPUT})

	FIND_PROGRAM(GZIP NAMES gzip)
	IF (NOT GZIP)
		MESSAGE(STATUS "Can't find gzip : will not build man pages")
	ELSE()
		ADD_CUSTOM_TARGET(man ALL COMMAND ${SPHINX_BUILD} -b man
									-c ${CMAKE_CURRENT_BINARY_DIR}/doc
									   ${CMAKE_CURRENT_SOURCE_DIR}/doc/man
        								   ${SPHINX_MAN_OUTPUT} &&
						  ${GZIP} -f ${SPHINX_MAN_OUTPUT}/*.1)
		INSTALL(FILES ${SPHINX_MAN_OUTPUT}/morse.1.gz ${SPHINX_MAN_OUTPUT}/morseexec.1.gz ${SPHINX_MAN_OUTPUT}/multinode_server.1.gz
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/man/man1
		)
	ENDIF()

	INSTALL(DIRECTORY ${SPHINX_OUTPUT}
			DESTINATION ${CMAKE_INSTALL_PREFIX}/share/doc/morse
			REGEX .doctrees.* EXCLUDE
			REGEX _sources.* EXCLUDE
			REGEX .*.inv EXCLUDE
			REGEX .buildinfo EXCLUDE
			)

	ADD_CUSTOM_TARGET(
		force_doc
		COMMAND ${SPHINX_BUILD} -b html 
								-c ${CMAKE_CURRENT_BINARY_DIR}/doc/
								${CMAKE_CURRENT_SOURCE_DIR}/doc/morse
								${SPHINX_OUTPUT}
	)

	ADD_CUSTOM_TARGET(
		latex_doc
		COMMAND ${SPHINX_BUILD} -b latex
								-c ${CMAKE_CURRENT_BINARY_DIR}/doc/
								${CMAKE_CURRENT_SOURCE_DIR}/doc/morse
								${SPHINX_LATEX_OUTPUT}
	)
ENDIF()
ENDIF()

### CPack ###
EXECUTE_PROCESS(COMMAND
				which dpkg
					OUTPUT_VARIABLE SYSTEST_DPKG)
EXECUTE_PROCESS(COMMAND
				which rpm
					OUTPUT_VARIABLE SYSTEST_RPM)
IF (SYSTEST_DPKG)
	SET(CPACK_GENERATOR "DEB")
ELSEIF (SYSTEST_RPM)
	SET(CPACK_GENERATOR "RPM")
ELSE ()
	SET(CPACK_GENERATOR "TGZ")
ENDIF()
# TODO find a better way to check debian or redhat ?

SET(CPACK_PACKAGE_CONTACT "morse-users <morse-users@laas.fr>")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "MORSE the Open Robots Simulator")
SET(CPACK_PACKAGE_NAME "openrobots-morse")
SET(CPACK_PACKAGE_VENDOR "CNRS/LAAS")
SET(CPACK_PACKAGE_VERSION ${PACKAGE_VERSION})
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
SET(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README")

SET(CPACK_DEBIAN_PACKAGE_DEPENDS "python3-dev")
SET(CPACK_DEBIAN_PACKAGE_HOMEPAGE "http://morse.openrobots.org")

INCLUDE(CPack)

### Uninstall ###
configure_file("${CMAKE_HOME_DIRECTORY}/config/cmake_uninstall.cmake.in" "cmake_uninstall.cmake" IMMEDIATE @ONLY)
add_custom_target(uninstall "${CMAKE_COMMAND}" -P "cmake_uninstall.cmake")

=== bindings/CMakeLists.txt ===

if (PYMORSE_SUPPORT)
	install(DIRECTORY pymorse/
        DESTINATION ${PYTHON_INSTDIR}
        REGEX .*py.$ EXCLUDE
        REGEX setup.py EXCLUDE
        )
endif()

=== doc/Makefile ===
VERSION=0.1.1
GUIDE_TITLE=User Guide
#GUIDE_TITLE=Developers Guide
BG_TEXT=v.$(VERSION)


GUIDE_TITLE_PROTECTED=$(shell echo $(GUIDE_TITLE) | sed 's/ /_/g' | tr A-Z a-z)

CONTENT=$(GUIDE_TITLE_PROTECTED).tex
COVER=cover.svg.in

PDF=morse_$(GUIDE_TITLE_PROTECTED)-$(VERSION).pdf

CONTENTpdf=$(CONTENT:.tex=.pdf)

COVERsvg=$(COVER:.svg.in=.svg)
COVERpdf=$(COVERsvg:.svg=.pdf)

all: $(PDF)

$(PDF): $(CONTENT) $(COVERpdf)

	sed 's/@BGTEXT@/$(BG_TEXT)/g' $(<) > $(PDF:.pdf=.tex)
	sed -i 's/@DATE@/\\today/g' $(PDF:.pdf=.tex)
	pdflatex $(PDF:.pdf=.tex)
	pdflatex $(PDF:.pdf=.tex)

$(COVERpdf): $(COVERsvg)  
	inkscape --export-pdf $(@) $(<)

$(COVERsvg): $(COVER)
	sed 's/@VERSION@/$(VERSION)/g' $(<) > $(@)-intermediate
	sed 's/@GUIDE_TITLE@/$(GUIDE_TITLE)/g' $(@)-intermediate > $(@)

clean:
	rm -f *.aux *.log *.snm *.out *.toc *.nav *intermediate *~ $(COVERsvg) $(COVERpdf) $(CONTENTpdf) $(PDF:.pdf=.tex)

distclean: clean
	rm -f $(PDF)

=== testing/CMakeLists.txt ===
macro(add_morse_test name)
	set(full_name ${CMAKE_CURRENT_SOURCE_DIR}/${name})
	string(REPLACE "${CMAKE_SOURCE_DIR}/testing/" "" test_name ${full_name})
	add_test(NAME ${test_name} COMMAND ${PYTHON3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/${name}.py)
endmacro()

if (BUILD_CORE_SUPPORT)
	add_subdirectory(base)
	add_subdirectory(robots/human)
endif()

if (BUILD_ROS_SUPPORT)
	add_subdirectory(middlewares/ros)
endif()

if (BUILD_YARP2_SUPPORT)
	add_subdirectory(middlewares/yarp)
endif()

=== src/morse/CMakeLists.txt ===

if(BUILD_CORE_SUPPORT)
INSTALL(FILES __init__.py #init_middleware.py
        DESTINATION ${PYTHON_INSTDIR}/morse
        )

INSTALL(DIRECTORY core actuators geolandloader helpers blender sensors services robots testing
        DESTINATION ${PYTHON_INSTDIR}/morse
        REGEX .*py.$ EXCLUDE
        )

ADD_SUBDIRECTORY(builder)
ADD_SUBDIRECTORY(modifiers)
endif()

ADD_SUBDIRECTORY(multinode)
ADD_SUBDIRECTORY(middleware)

=== testing/base/CMakeLists.txt ===
add_morse_test(base_testing)
add_morse_test(pose_testing)
add_morse_test(vw_testing)
add_morse_test(odometry_testing)
add_morse_test(waypoint_testing)
add_morse_test(sick_testing)
add_morse_test(kuka_lwr_testing)
add_morse_test(semantic_camera_testing)
add_morse_test(ned_testing)

=== src/morse/modifiers/CMakeLists.txt ===
# build and install C modifiers
INCLUDE_DIRECTORIES(${PYTHON3_INCLUDE_DIR})

ADD_LIBRARY (gaussian SHARED gaussian.c)
SET_TARGET_PROPERTIES (gaussian PROPERTIES PREFIX "")
SET_TARGET_PROPERTIES (gaussian PROPERTIES SUFFIX ".so")
TARGET_LINK_LIBRARIES (gaussian ${PYTHON3_LIBRARY})
INSTALL(TARGETS gaussian
		DESTINATION ${PYTHON_INSTDIR}/morse/modifiers)

# install python files
FILE(GLOB PYTHON_FILES *.py)
INSTALL(FILES ${PYTHON_FILES}
        DESTINATION ${PYTHON_INSTDIR}/morse/modifiers)

=== testing/middlewares/ros/CMakeLists.txt ===
add_morse_test(services)
add_morse_test(data_stream)

# action test used actionlib which only work for the moment with python2, so
# search for python2 and use it to run the test
find_package(PythonInterp)
if (PYTHONINTERP_FOUND)
	add_test(NAME "middleware/ros/actions.py" COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/actions.py)
else(PYTHONINTERP_FOUND)
	message(STATUS "Python2 interpreter not found, won't launch middleware/ros/actions.py test")
endif(PYTHONINTERP_FOUND)

=== testing/robots/human/CMakeLists.txt ===
add_morse_test(human_pose)

=== src/morse/middleware/pocolibs/CMakeLists.txt ===
##
## To add a sensor or an actuator to the build, just add it to the according
## list (actuator_list or sensor_list) and add the right entry in
## MODULES_MAP_{entry}
##
## It generates _ors_<module_name>_poster.so, ors_<module_name>_poster.py, and
## we wait for <module_name>.py in the (sensor|actuator) directory)

include_directories(${PYTHON3_INCLUDE_DIR})
include_directories(${POCOLIBS_INCLUDE_DIRS})
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")

link_directories(${POCOLIBS_LIBDIR})
#macro that upcases the first letter of a given string all_lower
macro(upcase_first all_lower first_upper)
	string(SUBSTRING ${all_lower} 0 1 first_letter)
	string(TOUPPER "${first_letter}" first_letter)
	string(LENGTH ${all_lower} length)
	math(EXPR length "${length} - 1")
	string(SUBSTRING ${all_lower} 1 ${length} ${first_upper})
	set(${first_upper} "${first_letter}${${first_upper}}")
endmacro(upcase_first)

set(directories_list "sensors;actuators")
set(sensors_list "general;viam;pom;velodyne;viman;human_posture;target;platine_posture")
set(actuators_list "genpos;platine;lwr")

## Set here the dependencies of your modules
## over Genom modules
set(MODULES_MAP_VIAM "viam;pom")
set(MODULES_MAP_GENERAL "")
set(MODULES_MAP_POM "pom")
set(MODULES_MAP_VELODYNE "velodyne;pom")
set(MODULES_MAP_VIMAN "viman")
set(MODULES_MAP_HUMAN_POSTURE "spark")
set(MODULES_MAP_GENPOS "genPos")
set(MODULES_MAP_TARGET "genPos")
set(MODULES_MAP_PLATINE "pom;platine")
set(MODULES_MAP_LWR "lwr;gbM;genBasic;genManip")
set(MODULES_MAP_PLATINE_POSTURE "platine")

foreach(directory ${directories_list})
	set(items_list "${directory}_list")
	foreach(item ${${items_list}})
		string(TOUPPER "${item}" ITEM)
		upcase_first(${item} Item)
		set(MODULE_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${directory}/${Item}_Poster")
		set(module_to_find "MODULES_MAP_${ITEM}")
		set(modules_additional_to_find "MODULES_MAP_${ITEM}_ADDITIONAL")
		set(module_to_find ${${module_to_find}})
		set(target_name "")
		if("${item}" STREQUAL "general")
			set(target_name "ors_poster")
		else("${module_to_find}" STREQUAL "")
			set(BUILD_MODULE_TO_FIND_SUPPORT "BUILD_POCOLIBS_${ITEM}_SUPPORT")
			option(${BUILD_MODULE_TO_FIND_SUPPORT} "build ${item} support" OFF)
			if (${BUILD_MODULE_TO_FIND_SUPPORT})

                foreach(dependency ${module_to_find})
		            string(TOUPPER "${dependency}" DEPENDENCY)
				    set(MODULE_INCLUDE_DIRS "${DEPENDENCY}_INCLUDE_DIRS")
                    #MESSAGE("Adding dependency ${dependency}")
				    pkg_check_modules(${DEPENDENCY} REQUIRED ${dependency})
				    include_directories(${${MODULE_INCLUDE_DIRS}})
                endforeach(dependency)

                set(target_name "ors_${item}_poster")

            endif (${BUILD_MODULE_TO_FIND_SUPPORT})

		endif("${item}" STREQUAL "general")

		if(("${module_to_find}" STREQUAL "") OR (${BUILD_MODULE_TO_FIND_SUPPORT}))
			include_directories(${MODULE_SOURCE_DIR})
			file(GLOB interface ${directory}/${Item}_Poster/*.i)
			file(GLOB source ${directory}/${Item}_Poster/*.c)
			
			set(ALL_INCLUDES)
			foreach(dependency ${module_to_find})
		        string(TOUPPER "${dependency}" DEPENDENCY)
				set(MODULE_INCLUDE_DIRS "${DEPENDENCY}_INCLUDE_DIRS")
				foreach (inc ${${MODULE_INCLUDE_DIRS}})
					set(ALL_INCLUDES ${ALL_INCLUDES} -I${inc})
				endforeach (inc ${${MODULE_INCLUDE_DIRS}})
			endforeach(dependency ${module_to_find})


			add_custom_command(
				OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${target_name}PYTHON_wrap.c 
				OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/${target_name}.py
				COMMAND ${SWIG_EXECUTABLE} 
				ARGS -python -outdir ${CMAKE_CURRENT_BINARY_DIR} 
									 -I${MODULE_SOURCE_DIR} 
									 ${ALL_INCLUDES} 
									 -o ${target_name}PYTHON_wrap.c ${interface}
				MAIN_DEPENDENCY ${interface}
				WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
				)

			add_library(${target_name} SHARED ${source} ${CMAKE_CURRENT_BINARY_DIR}/${target_name}PYTHON_wrap.c)
			set_target_properties(${target_name} PROPERTIES PREFIX "_")
			set_target_properties(${target_name} PROPERTIES SUFFIX ".so")
			target_link_libraries(${target_name} ${POCOLIBS_LIBRARIES} ${PYTHON3_LIBRARIES})
			install (FILES ${MODULE_SOURCE_DIR}/__init__.py 
				${CMAKE_CURRENT_BINARY_DIR}/_${target_name}.so 
				${CMAKE_CURRENT_BINARY_DIR}/${target_name}.py
				DESTINATION ${PYTHON_INSTDIR}/morse/middleware/pocolibs/${directory}/${Item}_Poster/
				)
		if(NOT "${module_to_find}" STREQUAL "")
		install(FILES ${directory}/${item}.py
				DESTINATION ${PYTHON_INSTDIR}/morse/middleware/pocolibs/${directory}
				)
		endif(NOT "${module_to_find}" STREQUAL "")
		endif(("${module_to_find}" STREQUAL "") OR (${BUILD_MODULE_TO_FIND_SUPPORT}))
	endforeach(item)
	install (FILES ${directory}/__init__.py
			 DESTINATION ${PYTHON_INSTDIR}/morse/middleware/pocolibs/${directory}
			 )
			
endforeach(directory)
install (FILES __init__.py
		DESTINATION ${PYTHON_INSTDIR}/morse/middleware/pocolibs
		)

=== testing/middlewares/ros/morsetesting/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.4.6)
include($ENV{ROS_ROOT}/core/rosbuild/rosbuild.cmake)

# Set the build type.  Options are:
#  Coverage       : w/ debug symbols, w/o optimization, w/ code-coverage
#  Debug          : w/ debug symbols, w/o optimization
#  Release        : w/o debug symbols, w/ optimization
#  RelWithDebInfo : w/ debug symbols, w/ optimization
#  MinSizeRel     : w/o debug symbols, w/ optimization, stripped binaries
#set(ROS_BUILD_TYPE RelWithDebInfo)
rosbuild_find_ros_package(actionlib_msgs)
include(${actionlib_msgs_PACKAGE_PATH}/cmake/actionbuild.cmake)
genaction()


rosbuild_init()

#set the default path for built executables to the "bin" directory
#set(EXECUTABLE_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/bin)
#set the default path for built libraries to the "lib" directory
#set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/lib)

#uncomment if you have defined messages
rosbuild_genmsg()
#uncomment if you have defined services
rosbuild_gensrv()

#common commands for building c++ executables and libraries
#rosbuild_add_library(${PROJECT_NAME} src/example.cpp)
#target_link_libraries(${PROJECT_NAME} another_library)
#rosbuild_add_boost_directories()
#rosbuild_link_boost(${PROJECT_NAME} thread)
#rosbuild_add_executable(example examples/example.cpp)
#target_link_libraries(example ${PROJECT_NAME})

=== debian/changelog ===
morse-simulator (0.5.2-1) unstable; urgency=low

  * Initial release (Closes: #670577)

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 26 Apr 2012 21:37:50 +0200

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/tarball\/(.+)$/morse-simulator_$1.orig.tar.gz/ \
https://github.com/laas/morse/tags .*/tarball/(\d[\d\.]+)

## morse-simulator 0.6~alpha

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,11 @@
 cmake_minimum_required(VERSION 2.6)
 
 set(PACKAGE_NAME morse)
-set(PACKAGE_VERSION 0.5.2)
+set(PACKAGE_VERSION "0.5.99") 
+
 
 option(BUILD_CORE_SUPPORT "Build and install morse core" ON)
-option(BUILD_DOC_SUPPORT "Build and install morse documentation (Requiere Sphinx)" ON)
+option(BUILD_DOC_SUPPORT "Build and install morse documentation (Requiere Sphinx)" OFF)
 
 option(BUILD_POCOLIBS_SUPPORT "Build pocolibs framework support" OFF)
 option(BUILD_YARP2_SUPPORT "Build yarp framework support" OFF)
@@ -34,7 +35,18 @@
 if(NOT PYTHON_INSTDIR)
 	SET(PYTHON_INSTDIR ${CMAKE_INSTALL_PREFIX}/${PYTHON_INSTALL}) 
 endif(NOT PYTHON_INSTDIR)
+if(WIN32)
+    STRING(REGEX REPLACE "\\\\" "/" PYTHON_INSTDIR ${PYTHON_INSTDIR})
+endif(WIN32)
 MESSAGE(STATUS "will install python files in ${PYTHON_INSTDIR}")
+
+# Compute revision
+ADD_CUSTOM_TARGET(revisiontag ALL)
+ADD_CUSTOM_COMMAND(TARGET revisiontag COMMAND ${CMAKE_COMMAND}
+	   -DSOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR} 
+	   -P ${CMAKE_CURRENT_SOURCE_DIR}/config/version.cmake)
+
+INSTALL(FILES ${CMAKE_BINARY_DIR}/version.py DESTINATION ${PYTHON_INSTDIR}/morse/)
 
 if (BUILD_YARP2_SUPPORT)
 	EXECUTE_PROCESS(COMMAND 
@@ -85,6 +97,21 @@
 		 REGEX .*clients.* EXCLUDE
 		)
 
+IF(WIN32)
+CONFIGURE_FILE(
+   ${CMAKE_CURRENT_SOURCE_DIR}/bin/morse.in
+   ${CMAKE_CURRENT_BINARY_DIR}/bin/morserun.py
+   )
+CONFIGURE_FILE(
+   ${CMAKE_CURRENT_SOURCE_DIR}/bin/multinode_server.in
+   ${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server.py
+   )
+INSTALL(PROGRAMS
+       ${CMAKE_CURRENT_BINARY_DIR}/bin/morserun.py
+       ${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server.py
+       DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
+       )
+ELSE(WIN32)
 CONFIGURE_FILE(
 	${CMAKE_CURRENT_SOURCE_DIR}/bin/morse.in
 	${CMAKE_CURRENT_BINARY_DIR}/bin/morse
@@ -103,6 +130,7 @@
 		${CMAKE_CURRENT_BINARY_DIR}/bin/multinode_server
 		DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
 	    )
+ENDIF(WIN32)
 ENDIF()
 
 ADD_SUBDIRECTORY(bindings)
@@ -130,26 +158,26 @@
 
 FIND_PROGRAM(SPHINX_BUILD NAMES sphinx-build)
 IF (NOT SPHINX_BUILD)
-	MESSAGE(STATUS "Can't find sphinx-build : will not build the documentation")
+	MESSAGE(FATAL_ERROR "Can't find sphinx-build : will not build the documentation")
 ELSE()
 	SET (SPHINX_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc/html)
 	SET (SPHINX_LATEX_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc/tex)
 	SET (SPHINX_MAN_OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/doc/man)
-	ADD_CUSTOM_COMMAND(
-		OUTPUT ${SPHINX_OUTPUT}
-		COMMAND ${SPHINX_BUILD} -b html
+	SET (SPHINX_BUILD_ENV env PYTHONPATH=$$PYTHONPATH:${CMAKE_CURRENT_BINARY_DIR}:${CMAKE_CURRENT_SOURCE_DIR}/src ${SPHINX_BUILD})
+	ADD_CUSTOM_TARGET(
+		doc ALL
+		COMMAND ${SPHINX_BUILD_ENV} -b html
 								-c ${CMAKE_CURRENT_BINARY_DIR}/doc
 								   ${CMAKE_CURRENT_SOURCE_DIR}/doc/morse
 								   ${SPHINX_OUTPUT}
 	)
-
-	ADD_CUSTOM_TARGET(doc ALL DEPENDS ${SPHINX_OUTPUT})
+	ADD_DEPENDENCIES(doc revisiontag)
 
 	FIND_PROGRAM(GZIP NAMES gzip)
 	IF (NOT GZIP)
 		MESSAGE(STATUS "Can't find gzip : will not build man pages")
 	ELSE()
-		ADD_CUSTOM_TARGET(man ALL COMMAND ${SPHINX_BUILD} -b man
+		ADD_CUSTOM_TARGET(man ALL COMMAND ${SPHINX_BUILD_ENV} -b man
 									-c ${CMAKE_CURRENT_BINARY_DIR}/doc
 									   ${CMAKE_CURRENT_SOURCE_DIR}/doc/man
         								   ${SPHINX_MAN_OUTPUT} &&
@@ -168,16 +196,8 @@
 			)
 
 	ADD_CUSTOM_TARGET(
-		force_doc
-		COMMAND ${SPHINX_BUILD} -b html 
-								-c ${CMAKE_CURRENT_BINARY_DIR}/doc/
-								${CMAKE_CURRENT_SOURCE_DIR}/doc/morse
-								${SPHINX_OUTPUT}
-	)
-
-	ADD_CUSTOM_TARGET(
-		latex_doc
-		COMMAND ${SPHINX_BUILD} -b latex
+		latex_doc 
+		COMMAND ${SPHINX_BUILD_ENV} -b latex
 								-c ${CMAKE_CURRENT_BINARY_DIR}/doc/
 								${CMAKE_CURRENT_SOURCE_DIR}/doc/morse
 								${SPHINX_LATEX_OUTPUT}
@@ -210,7 +230,7 @@
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
 SET(CPACK_RESOURCE_FILE_README "${CMAKE_CURRENT_SOURCE_DIR}/README")
 
-SET(CPACK_DEBIAN_PACKAGE_DEPENDS "python3-dev")
+SET(CPACK_DEBIAN_PACKAGE_DEPENDS "python3.2-dev")
 SET(CPACK_DEBIAN_PACKAGE_HOMEPAGE "http://morse.openrobots.org")
 
 INCLUDE(CPack)

=== testing/CMakeLists.txt ===
--- 
+++ 
@@ -7,10 +7,12 @@
 if (BUILD_CORE_SUPPORT)
 	add_subdirectory(base)
 	add_subdirectory(robots/human)
+	add_subdirectory(robots/segway)
 endif()
 
 if (BUILD_ROS_SUPPORT)
 	add_subdirectory(middlewares/ros)
+	add_subdirectory(robots/pr2)
 endif()
 
 if (BUILD_YARP2_SUPPORT)

=== src/morse/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,7 @@
 
 ADD_SUBDIRECTORY(builder)
 ADD_SUBDIRECTORY(modifiers)
+ADD_SUBDIRECTORY(sensors)
 endif()
 
 ADD_SUBDIRECTORY(multinode)

=== testing/base/CMakeLists.txt ===
# Base concept 

add_morse_test(base_testing)

# Sensor

add_morse_test(battery_testing)
add_morse_test(gps_testing)
add_morse_test(gyroscope_testing)
add_morse_test(odometry_testing)
add_morse_test(pose_testing)
add_morse_test(proximity_testing)
add_morse_test(sick_testing)
add_morse_test(semantic_camera_testing)
add_morse_test(video_camera_testing)

# Actuator

add_morse_test(armature_actuator_testing)
add_morse_test(destination_testing)
add_morse_test(orientation_testing)
add_morse_test(steer_force_testing)
add_morse_test(stabilized_quadrotor)
add_morse_test(teleport_testing)
add_morse_test(vw_testing)
add_morse_test(waypoint_testing)

# Sensor + Actuator 

add_morse_test(kuka_lwr_testing) 
add_morse_test(ptu_testing)

# Modifier

add_morse_test(ned_testing)
add_morse_test(utm_mod_testing)

=== examples/clients/ressac/Makefile ===
# Makefile to compile control scripts

# Location of include libraries
OPENROBOTS_BASE = $(HOME)/openrobots

CC = g++

CFLAGS = -g
LDFLAGS = -I$(OPENROBOTS_BASE)/include -L$(OPENROBOTS_BASE)/lib -lYARP_OS -Wl,-rpath,$(OPENROBOTS_BASE)/lib

RESSAC = ressac_client

all: $(RESSAC)

$(RESSAC): $(RESSAC).o
	$(CC) $(CFLAGS) $(LDFLAGS) -o $@ $^

%.o: %.cpp
	$(CC) $(CFLAGS) $(LDFLAGS) -c -o $@ $^

tags:
	ctags *c *.h

clean:
	-rm -f *.o

distclean: clean
	rm ${RESSAC}

.PHONY: all clean tags

=== src/morse/builder/CMakeLists.txt ===

FILE(GLOB PYTHON_FILES *.py)
INSTALL(FILES ${PYTHON_FILES} 
        DESTINATION ${PYTHON_INSTDIR}/morse/builder
        )

INSTALL(DIRECTORY extensions
        DESTINATION ${PYTHON_INSTDIR}/morse/builder
        REGEX .*py.$ EXCLUDE
        )

=== src/morse/middleware/CMakeLists.txt ===

if (BUILD_CORE_SUPPORT)
INSTALL(FILES __init__.py socket_mw.py text_mw.py socket_request_manager.py 
	    DESTINATION ${PYTHON_INSTDIR}/morse/middleware
		)

INSTALL(DIRECTORY sockets
		 DESTINATION ${PYTHON_INSTDIR}/morse/middleware)
endif()

IF(BUILD_YARP2_SUPPORT)
	INSTALL(DIRECTORY yarp
        DESTINATION ${PYTHON_INSTDIR}/morse/middleware
        REGEX .*py.$ EXCLUDE
        )
	INSTALL(FILES yarp_mw.py yarp_request_manager.py yarp_json_request_manager.py
		DESTINATION ${PYTHON_INSTDIR}/morse/middleware
		)
ENDIF(BUILD_YARP2_SUPPORT)

IF(BUILD_POCOLIBS_SUPPORT)
	ADD_SUBDIRECTORY(pocolibs)
	INSTALL(FILES pocolibs_mw.py pocolibs_request_manager.py
			DESTINATION ${PYTHON_INSTDIR}/morse/middleware)
ENDIF(BUILD_POCOLIBS_SUPPORT)

IF(BUILD_ROS_SUPPORT)
  INSTALL(DIRECTORY ros
        DESTINATION ${PYTHON_INSTDIR}/morse/middleware
        REGEX .*py.$ EXCLUDE
        )
  INSTALL(FILES ros_mw.py ros_request_manager.py
			DESTINATION ${PYTHON_INSTDIR}/morse/middleware
      )
ENDIF(BUILD_ROS_SUPPORT)

IF(BUILD_MOOS_SUPPORT)
  INSTALL(DIRECTORY moos
        DESTINATION ${PYTHON_INSTDIR}/morse/middleware
        REGEX .*py.$ EXCLUDE
        )
  INSTALL(FILES moos_mw.py 
	    DESTINATION ${PYTHON_INSTDIR}/morse/middleware
		)
ENDIF(BUILD_MOOS_SUPPORT)

=== src/morse/modifiers/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,11 @@
 
 ADD_LIBRARY (gaussian SHARED gaussian.c)
 SET_TARGET_PROPERTIES (gaussian PROPERTIES PREFIX "")
-SET_TARGET_PROPERTIES (gaussian PROPERTIES SUFFIX ".so")
+if (WIN32)
+    ADD_DEFINITIONS(-D_WIN32)
+else (WIN32)
+    SET_TARGET_PROPERTIES (gaussian PROPERTIES SUFFIX ".so")
+endif (WIN32)
 TARGET_LINK_LIBRARIES (gaussian ${PYTHON3_LIBRARY})
 INSTALL(TARGETS gaussian
 		DESTINATION ${PYTHON_INSTDIR}/morse/modifiers)

=== src/morse/sensors/CMakeLists.txt ===
# build and install C sensors
INCLUDE_DIRECTORIES(${PYTHON3_INCLUDE_DIR})

#ADD_LIBRARY (sickc SHARED sickcmodule.c)
#SET_TARGET_PROPERTIES (sickc PROPERTIES PREFIX "")
#if (WIN32)
#    ADD_DEFINITIONS(-D_WIN32)
#else (WIN32)
#    SET_TARGET_PROPERTIES (sickc PROPERTIES SUFFIX ".so")
#endif (WIN32)
#TARGET_LINK_LIBRARIES (sickc ${PYTHON3_LIBRARY})
#INSTALL(TARGETS sickc
#		DESTINATION ${PYTHON_INSTDIR}/morse/sensors)

ADD_LIBRARY (zBuffTo3D SHARED zBuffTo3Dmodule.c)
SET_TARGET_PROPERTIES (zBuffTo3D PROPERTIES PREFIX "")
if (WIN32)
    ADD_DEFINITIONS(-D_WIN32)
else (WIN32)
    SET_TARGET_PROPERTIES (zBuffTo3D PROPERTIES SUFFIX ".so")
endif (WIN32)
TARGET_LINK_LIBRARIES (zBuffTo3D ${PYTHON3_LIBRARY})
INSTALL(TARGETS zBuffTo3D
		DESTINATION ${PYTHON_INSTDIR}/morse/sensors)


# install python files
FILE(GLOB PYTHON_FILES *.py)
INSTALL(FILES ${PYTHON_FILES}
        DESTINATION ${PYTHON_INSTDIR}/morse/sensors)

=== testing/middlewares/yarp/CMakeLists.txt ===
add_morse_test(yarp_mw_testing)

=== testing/robots/pr2/CMakeLists.txt ===
add_morse_test(jointstate)

=== testing/robots/segway/CMakeLists.txt ===
add_morse_test(segway_vw)

=== debian/changelog ===
morse-simulator (0.6~alpha-1~exp1) experimental; urgency=low

  * New upstream release (Fix problem with blender 2.65)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 10 Sep 2012 16:48:34 +0200

=== debian/control ===
Source: morse-simulator
Section: science
Priority: extra
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>, Séverin Lemaignan <severin@guakamole.org>
Build-Depends: debhelper (>= 8.0.0), cmake, python3.2, python3.2-dev,
 python3-sphinx, pkg-config
Standards-Version: 3.9.3
Homepage: http://morse.openrobots.org/
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/morse/trunk/
Vcs-Browser: http://svn.debian.org/viewsvn/debian-science/packages/morse/trunk/


Package: morse-simulator
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, blender (>= 2.59),
 ${python:Depends}, morse-simulator-data
Recommends: morse-simulator-doc
Conflicts: morse
Description: Multi-OpenRobot Simulation Engine
 List of morse features:
  * Versatile simulator for generic mobile robots simulation
    (single or multi robots),
  * Realistic and dynamic environments (interaction with other agents like
    humans or objects),
  * Based on well known and widely adopted open source projects (Blender for 3D
    rendering + UI, Bullet for physics simulation, dedicated robotic
    middlewares for communications + robot hardware support),
  * Seamless workflow: since the simulator rely on Blender for both modeling
    and the real time 3D engine, creating and modifying a simulated scene is
    straightforward.
  * Entirely scriptable in Python,
  * Adaptable to various level of simulation realism (for instance the
    simulation of exteroceptive sensors like cameras or a direct access to
    higher level representations of the world, like labeled artifacts),
  * Currently compatible with ROS, YARP and the LAAS OpenRobots robotics
    frameworks,
  * Easy to integrate to other environments via a simple socket interface,
  * Fully open source, BSD license.

Package: morse-simulator-data
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Multi-OpenRobot Simulation Engine
 List of morse features:
  * Versatile simulator for generic mobile robots simulation
    (single or multi robots),
  * Realistic and dynamic environments (interaction with other agents like
    humans or objects),
  * Based on well known and widely adopted open source projects (Blender for 3D
    rendering + UI, Bullet for physics simulation, dedicated robotic
    middlewares for communications + robot hardware support),
  * Seamless workflow: since the simulator rely on Blender for both modeling
    and the real time 3D engine, creating and modifying a simulated scene is
    straightforward.
  * Entirely scriptable in Python,
  * Adaptable to various level of simulation realism (for instance the
    simulation of exteroceptive sensors like cameras or a direct access to
    higher level representations of the world, like labeled artifacts),
  * Currently compatible with ROS, YARP and the LAAS OpenRobots robotics
    frameworks,
  * Easy to integrate to other environments via a simple socket interface,
  * Fully open source, BSD license.
 .
 This package contains morse data.

Package: morse-simulator-doc
Section: doc
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Multi-OpenRobot Simulation Engine - Documentation
 List of morse features:
  * Versatile simulator for generic mobile robots simulation
    (single or multi robots),
  * Realistic and dynamic environments (interaction with other agents like
    humans or objects),
  * Based on well known and widely adopted open source projects (Blender for 3D
    rendering + UI, Bullet for physics simulation, dedicated robotic
    middlewares for communications + robot hardware support),
  * Seamless workflow: since the simulator rely on Blender for both modeling
    and the real time 3D engine, creating and modifying a simulated scene is
    straightforward.
  * Entirely scriptable in Python,
  * Adaptable to various level of simulation realism (for instance the
    simulation of exteroceptive sensors like cameras or a direct access to
    higher level representations of the world, like labeled artifacts),
  * Currently compatible with ROS, YARP and the LAAS OpenRobots robotics
    frameworks,
  * Easy to integrate to other environments via a simple socket interface,
  * Fully open source, BSD license.
 . 
 This package contains the documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@
# --builddirectory=build

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_DOC_SUPPORT=ON

#override_dh_auto_build:
#	make -C build all doc

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/tarball\/(.+)$/morse-simulator_$1.orig.tar.gz/ \
https://github.com/laas/morse/tags .*/tarball/(\d[\d\.]+.*)
